double *CreateONEDimensionalArray( unsigned int  uisize);
int **CreateTwoDimensionalArray ( unsigned int  uiYsize, unsigned int uiXsize);
void DeleteTwoDimensionalArray(int **ppiHead, int  uiYsize,  int uiXsize);
double **d_CreateTwoDimensionalArray(unsigned  int  uiYsize, unsigned int uiXsize);

double **AVG_matrix_x(int **a,int pixel,int P_NO);
double *AVG_matrix_y(double **a,int pixel,int P_NO);

double **multiplication( double **a, double **b,int pixel,int P_NO);

int **transposed_matrix(int **a,int pixel,int P_NO);
double **d_transposed_matrix( double **a,int pixel,int P_NO); 

int * ReadPgm(int  *iWidth, int *iHeight, int *iMaxValue);
void WritePgm(int * piOutputData, int iWidth, int iHeight, int iMaxValue);

struct DATA Jacobi(double **A,int n,int pixel,struct DATA d);

double **Autocorrelation_matrix( int **a, int **b,int pixel,int P_NO);

double **eigenface(struct DATA d,int **b,int pixel,int P_NO);

double similarity(double **a,int *b,int pixel,int NO);

double *LSM(double *read,int pixel);

int BP(struct ID *mid,int nb);
int InitBp(bp_nn *bp,int nb);
int TrainBp(bp_nn *bp, double **x, int **y,int nb);
int UseBp(bp_nn *bp,int nb);
double fnet(double net);

